#include<iostream>// cout 
using namespace std;
#include<stdlib>  // random()
#include<conio>   // cprintf()
#include<math>    // 2^x  M_E
#include<dos>     // date & time
#pragma hdrstop
#include"TVDStree.h"

int** matrix;
int dimension;

// ===================================================================================== TVDS
bool* n_tupel;
TVDS_tree* calculated = NULL;
extern TVDS_tree* lastleaf;
long double reks;

int TVDS(int rekdepth = 0)
   {
   int ret = 0;

   int* leafcont = findleaf(calculated, n_tupel);
   if(leafcont != NULL)
      return(*(leafcont));

   reks++;
   TVDS_tree* leaf = lastleaf;
   if(rekdepth == dimension-2)                    // 2x2 Unterdeterminante explizit berechnen
      {
      int sa; for(sa = 0; sa < dimension; sa++) if(n_tupel[sa]) break;
      int sb; for(sb = sa+1; sb < dimension; sb++) if(n_tupel[sb]) break;
      int za = dimension-2;
      int zb = dimension-1;
      leaf->content = new(int);                          // berechnete Determinante speichern
      *(leaf->content) = matrix[za][sa] * matrix[zb][sb] - matrix[za][sb] * matrix[zb][sa];
      return(*(leaf->content));
      }

   int faktor = 1;
   for(int i = 0; i < dimension; i++)                            // Schleife ber die spalten
      if(n_tupel[i])
         {
         n_tupel[i] = false;                                              // Spalte streichen
         ret += faktor * matrix[rekdepth][i] * TVDS(rekdepth+1);                 // Rekursion
         n_tupel[i] = true;                                               // Spalte freigeben

         faktor *= -1;
         }

   leaf->content = new(int);                       // fertig bestimmte Determinante speichern
   *(leaf->content) = ret;
   return(ret);                                           // (Unter-)Determinante zurckgeben
   }

// ================================================================================== Laplace
bool* ospalten;
long double lpreks;
int Laplace(int rekdepth = 0)
   {
   int ret = 0;
   lpreks++;

   if(rekdepth == dimension-2)                    // 2x2 Unterdeterminante explizit berechnen
      {
      int sa; for(sa = 0; sa < dimension; sa++) if(ospalten[sa]) break;
      int sb; for(sb = sa+1; sb < dimension; sb++) if(ospalten[sb]) break;
      int za = dimension-2;
      int zb = dimension-1;
      return(matrix[za][sa] * matrix[zb][sb] - matrix[za][sb] * matrix[zb][sa]);
      }

   int faktor = 1;                                               // Schleife ber die spalten
   for(int i = 0; i < dimension; i++)
      if(ospalten[i])
         {
         ospalten[i] = false;                                             // Spalte streichen
         ret += faktor * Laplace(rekdepth+1) * matrix[rekdepth][i];              // Rekursion
         ospalten[i] = true;                                              // Spalte freigeben

         faktor *= -1;
         }
   return(ret);                                           // (Unter-)Determinante zurckgeben
   }

// ===================================================================================== MAIN

long double it_fac(long double x)
   {
   long double facuilty = 1.0;
   for(;x > 1; x--)            // here we decrease x, after multiplying "facuilty" with it
      facuilty *= x;                                   // x! = x * (x-1) * (x-2) * ... * 1
   return(facuilty);
   }

void main()
   {
   struct dosdate_t d;
   struct dostime_t t;
   _dos_getdate(&d);
   _dos_gettime(&t);

   cprintf("\n\r  Aufwands-Korrektheits Test            ");
   cprintf("%02i.%02i.%04i    %02i:%02i",d.day,d.month,d.year,t.hour,t.minute);
   cprintf("\n\r  ---------------------------------------------------------\n\r");
   cprintf("    n   |  n!*(e-2)  |   Rlp(n)   | (2^n)-n-1  |  Rtvds(n) \n\r");
   cprintf("  ------+------------+------------+------------+-----------\n\r  ");

   #define maxdim 25

   ospalten = new(bool[maxdim]);
   n_tupel = new(bool[maxdim]);
   matrix = new(int*[maxdim]);
   randomize();
   for(int i = 0; i < maxdim; i++)
      {
      ospalten[i] = true;
      n_tupel[i] = true;
      matrix[i] = new(int[maxdim]);
      }
   for(int i = 3; i < maxdim; i++)
      {
      dimension = i;
      calculated = new(TVDS_tree);
      for(int k = 0; k < dimension; k++)
         for(int j = 0; j < dimension; j++)
            matrix[k][j] = random(9)+1;
      reks = 0;
      lpreks = 0;
      if(dimension < 14)
         Laplace();
      TVDS();

      cprintf("%2ix%-2i | ",i,i);
      if(dimension < 14)
         {
         cout.width(10);
         cout.precision(15);
         long double e = M_E;
         cout << floorl((e-2.0) * it_fac(dimension)) << " | ";
         cout.width(10);
         cout.precision(15);
         cout << lpreks << " | ";
         }
      else
         cout << "           |            | ";
      cout.width(10);
      cout << (ldexp(1,dimension)-dimension-1) << " | ";
      cout.width(10);
      cout << reks << "\n  ";

      delete(calculated);
      }
   delete(ospalten);
   delete(n_tupel);
   for(int i = 0; i < dimension; i++)
      delete(matrix[i]);
   delete(matrix);
   getch();
   }
